import java.util.*;
import java.util.List;

import org.eclipse.swt.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;

public class OsxToolbarTooltipBug {

	// Static =================================================================

	public static void main(String[] args) {
		final Display display = new Display();

		final Shell shell = new Shell(display);
		final ToolBar toolBar = shell.getToolBar();

		final List<Image> images = new ArrayList<>();
		createToolItem("Red", SWT.COLOR_RED, SWT.PUSH, display, toolBar, images);
		createToolItem("Green", SWT.COLOR_GREEN, SWT.PUSH, display, toolBar, images);
		createToolItem("Blue", SWT.COLOR_BLUE, SWT.PUSH, display, toolBar, images);

		createToolItem("Dark Red", SWT.COLOR_DARK_RED, SWT.DROP_DOWN, display, toolBar, images);

		createToolItem("Dark Green", SWT.COLOR_DARK_GREEN, SWT.PUSH, display, toolBar, images);
		createToolItem("Dark Blue", SWT.COLOR_DARK_BLUE, SWT.PUSH, display, toolBar, images);

		shell.setSize(500, 200);
		shell.open();

		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}

		for (Image image : images) {
			image.dispose();
		}
		display.dispose();
	}

	// Utils ==================================================================

	private static void createToolItem(String text, int colorConstant, int style, Display display, ToolBar toolBar, List<Image> images) {
		final Image image = createImage(colorConstant, display, images);
		final ToolItem toolItem = new ToolItem(toolBar, style);
		toolItem.setImage(image);
		toolItem.setText(text);
		toolItem.setToolTipText(text);
	}

	private static Image createImage(int colorConstant, Display display, List<Image> images) {
		final int size = 24;
		final Image image = new Image(display, size, size);
		final GC gc = new GC(image);
		gc.setBackground(display.getSystemColor(colorConstant));
		gc.fillRectangle(0, 0, size, size);
		gc.dispose();
		images.add(image);
		return image;
	}
}