package com.syntevo.openapi.smartsvn.command.commit;

import java.util.*;

import org.apache.subversion.javahl.*;
import org.jetbrains.annotations.*;

import com.syntevo.openapi.smartsvn.command.*;
import com.syntevo.openapi.smartsvn.file.*;

/**
 * @author syntevo GmbH
 */
public abstract class FilterPostCommandPhase implements ICommitPostCommandPhase {

	// Fields =================================================================

	private final ICommitPostCommandPhase wrappedPhase;

	// Setup ==================================================================

	protected FilterPostCommandPhase(@NotNull ICommitPostCommandPhase wrappedPhase) {
		this.wrappedPhase = wrappedPhase;
	}

	// Implemented ============================================================

	@Override
	public void process(@NotNull Map<Path, ClientNotifyInformation> pathToClientNotifyInformation, @NotNull SvnClients svnClients) throws SubversionException {
		wrappedPhase.process(pathToClientNotifyInformation, svnClients);
	}
}
