package com.syntevo.openapi.smartsvn.file;

import org.jetbrains.annotations.*;

/**
 * Represents the subversion property of a file/directory.
 */
public interface SvnProperty {

	// Constants ==============================================================

	public static final String SVN_PREFIX = "svn:";
	public static final String MERGE_INFO = SVN_PREFIX + "mergeinfo";

	// Accessing ==============================================================

	@NotNull String getName();

	/**
	 * Always returns null if isString is false.
	 */
	@Nullable String getString();

	/**
	 * Returns the bytes for both binary and string properties.
	 */
	@Nullable byte[] getBytes();

	boolean isString();

	boolean isBinary();
}
